unit UFormTest2D;

interface

uses
  // Delphi includes:
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DateUtils, Math, StdCtrls, Buttons, ComCtrls, ExtDlgs,
  Menus, AppEvnts,
  // Project includes:
  UTrack2D, UTeam, UPhysic2D,
  // Players
  UPolygon2D, UKart, URocket;

type
  TFormTest2D = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Loadcircuit800x600BMP1: TMenuItem;
    Saveimagestofolder: TMenuItem;
    OpenPictureDialog: TOpenPictureDialog;
    SaveDialog: TSaveDialog;
    Graphicdebuglevels1: TMenuItem;
    MenuDebugTraces: TMenuItem;
    MenuDebugOptions: TMenuItem;
    Panel3: TPanel;
    PanelImg: TPanel;
    ImgRoad: TImage;
    Panel4: TPanel;
    GroupBox3: TGroupBox;
    StartBtn: TSpeedButton;
    PauseBtn: TSpeedButton;
    EdTrackParams: TGroupBox;
    Label5: TLabel;
    Label8: TLabel;
    LbFriction: TLabel;
    LbSideFriction: TLabel;
    EdPlayerParams: TGroupBox;
    EdHandMove: TGroupBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    LbRadio: TLabel;
    EdFriction: TTrackBar;
    EdSideFriction: TTrackBar;
    EdRadio: TTrackBar;
    edChoosePlayer: TGroupBox;
    EdColor: TPanel;
    EdPlayerId: TComboBox;
    ColorDialog: TColorDialog;
    BtnAddPlayer: TSpeedButton;
    EdAutoRadio: TCheckBox;
    BtnReset: TSpeedButton;
    BtnSubPlayer: TSpeedButton;
    EdCollisions: TCheckBox;
    Addaformation1: TMenuItem;
    Addacircleofkarts1: TMenuItem;
    MenuDebugGoals: TMenuItem;
    MenuDebugTeamGoals: TMenuItem;
    Addateamgoalforcollectingdrops1: TMenuItem;
    Addateamgoalforstoringcollecteddrops1: TMenuItem;
    AvoidOtherPlayers: TMenuItem;
    Label3: TLabel;
    LbSize: TLabel;
    EdSize: TTrackBar;
    SpeedButton7: TSpeedButton;
    Addagoal1: TMenuItem;
    N2: TMenuItem;
    DeleteallTeamsGoals1: TMenuItem;
    SpeedButton8: TSpeedButton;
    PanelView1: TMenuItem;
    menuChoosePlayer: TMenuItem;
    menuPlayerParams: TMenuItem;
    MenuTrackParams: TMenuItem;
    menuHandMove: TMenuItem;
    menuGoals: TMenuItem;
    Runfast1: TMenuItem;
    Keepenergyhunger1: TMenuItem;
    Deleteallplayerspersonalgoals1: TMenuItem;
    SpeedButton9: TSpeedButton;
    PopupGoalParam: TPopupMenu;
    EdAIParams: TGroupBox;
    LbSeconds: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    LbMinFutures: TLabel;
    EdSeconds: TTrackBar;
    EdMinFutures: TTrackBar;
    N1: TMenuItem;
    N3: TMenuItem;
    menuBasicAIparams: TMenuItem;
    MenuDebugLevels: TMenuItem;
    Keephealth1: TMenuItem;
    Suckenergyfromplayersinfrontofyou1: TMenuItem;
    FollowMouse: TMenuItem;
    AvoidMouse: TMenuItem;
    N5: TMenuItem;
    EdEvolution: TCheckBox;
    EdGoals: TPanel;
    ArrowTimer: TTimer;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    EdSensitivity: TCheckBox;
    N4: TMenuItem;
    Addatriangle1: TMenuItem;
    Addlotsofasteroids1: TMenuItem;
    MenuDebugFeelings: TMenuItem;
    Label4: TLabel;
    LbDetermined: TLabel;
    EdDetermined: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure AddPlayer(kind: integer);
    procedure EdFrictionChange(Sender: TObject);
    procedure EdSideFrictionChange(Sender: TObject);
    procedure ResetBtnClick(Sender: TObject);
    procedure EdDebugChange(Sender: TObject);
    procedure CopyParamsFromScreen;
    procedure CopyParamsFromPlayer;
    procedure UpdateGoals;
    procedure UpdateRealTimeParams;
    procedure Loadcircuit800x600BMP1Click(Sender: TObject);
    procedure SaveimagestofolderClick(Sender: TObject);
    procedure Pausesimulation1Click(Sender: TObject);
    procedure EdSecondsChange(Sender: TObject);
    procedure EdSizeChange(Sender: TObject);
    procedure EdRadioChange(Sender: TObject);
    procedure BtnAddPlayerClick(Sender: TObject);
    procedure EdPlayerIdChange(Sender: TObject);
    procedure EdColorClick(Sender: TObject);
    procedure EdAutoRadioClick(Sender: TObject);
    procedure EdSensitivityClick(Sender: TObject);
    procedure BtnSubPlayerClick(Sender: TObject);
    procedure EdCollisionsClick(Sender: TObject);
    procedure EdMinFuturesChange(Sender: TObject);
    procedure Addacircleofkarts1Click(Sender: TObject);
    procedure Addateamgoalforcollectingdrops1Click(Sender: TObject);
    procedure Addateamgoalforstoringcollecteddrops1Click(Sender: TObject);
    procedure AvoidOtherPlayersClick(Sender: TObject);
    procedure DeleteallTeamsGoals1Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure menuPlayerParamsClick(Sender: TObject);
    procedure Runfast1Click(Sender: TObject);
    procedure Deleteallplayerspersonalgoals1Click(Sender: TObject);
    procedure Keepenergyhunger1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Keephealth1Click(Sender: TObject);
    procedure Suckenergyfromplayersinfrontofyou1Click(Sender: TObject);
    procedure FollowMouseClick(Sender: TObject);
    procedure EdPlayerIdEnter(Sender: TObject);
    procedure EdEvolutionClick(Sender: TObject);
    procedure SpeedButton8DblClick(Sender: TObject);
    procedure MoveButtonMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MoveButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ArrowTimerTimer(Sender: TObject);
    procedure Addlotsofasteroids1Click(Sender: TObject);
    procedure EdDeterminedChange(Sender: TObject);
  private
    ImgNumber: integer;
    MyTrack: TTrack2D;
    procedure ClearPlayers;
    function  GetMyTeam: TTeam;
    function  GetMyPlayer: TPhysic2D;
    procedure RunSimulation;
    procedure ReadGoalStrength(Sender: TObject);
    procedure ReadGoalReactionTime(Sender: TObject);
    procedure ReadGoalUrgency(Sender: TObject);
    procedure HandMove(dir: integer);
  public
    property MyTeam: TTeam read GetMyTeam;
    property MyPlayer: TPhysic2D read GetMyPlayer;
  end;

var
  FormTest2D: TFormTest2D;

implementation

uses UPlayer, UUtils, UGoal,
     // Goal units
     UGoal2dRaced, UGoalEnergy, UGoalHealth,
     UGoal2DSweets, UGoal2dStorage, UGoalBurnOut, UGoal2DTeamAway, UGoalMouse;


{$R *.dfm}


// *************************
// ** ADMINISTRATVE STUFF **
// *************************

// Form creation: add a track, a team and a player, so it is ready to run:
procedure TFormTest2D.FormCreate(Sender: TObject);
begin
  randomize;
  OpenPictureDialog.InitialDir:= ExtractFilePath(ParamStr(0));
  SaveDialog.InitialDir:= ExtractFilePath(ParamStr(0));
  ImgNumber:= 1;
  // Activate info panels:
  menuPlayerParamsClick(nil);
  // Create the track:
  MyTrack:= TTrack2D.create;
  // A sample track is already loaded, scan it for black pixels.
  MyTrack.Img:= ImgRoad;
  // Add a team to the track:
  MyTrack.AddTeam(TTeam.create);

  // Add a player to the team:
  AddPlayer(2);

  // Set things for testing:
  Addateamgoalforcollectingdrops1Click(nil);
  //MenuDebugTraces.Checked:=  true;
  MenuDebugFeelings.Checked:=  true;
  //MenuDebugOptions.Checked:= true;
  EdDebugChange(nil);

  // Initial draw:
  MyTrack.draw(-1);
end;


// *********************
// **  ADD FORMATIONS **
// *********************

// Those formastions are for testing purpouse, the graphic interface doesn't
// allows you to set all the available options.

// Delete all players on the track:
procedure TFormTest2D.ClearPlayers;
begin
  while (MyTeam.PlayerCount > 0) do
    MyTeam.DelPlayer(MyPlayer, true);
  EdPlayerId.Clear;
end;

// Add a formation: circle with 36 karts
procedure TFormTest2D.Addacircleofkarts1Click(Sender: TObject);
const NKart: integer = 18;
var i: integer;
begin
  // Del all players:
  ClearPlayers;
  // Add a cricle of N karts at (400, 300) radius 100
  for i:= 0 to (NKart-1) do begin
    AddPlayer(0);
    TKart(MyPlayer).MaxPower:= 14;
    MyPlayer.Size:= 8;
    MyPlayer.PosX:= 400 + 90 * cos(i*(2*PI/NKart));
    MyPlayer.PosY:= 300 + 90 * sin(i*(2*PI/NKart));
    MyPlayer.Angle:= PI + i*(2*PI/NKart);
  end;
  // Redraw:
  MyTrack.draw(-1);
end;


// ********************
// ** PLAYER'S GOALS **
// ********************

procedure TFormTest2D.Deleteallplayerspersonalgoals1Click(Sender: TObject);
var
  OldId, i: integer;
begin
  OldId:= EdPlayerId.ItemIndex;
  for i:= 0 to EdPlayerId.Items.Count-1 do begin
    EdPlayerId.ItemIndex:= i;
    EdPlayerIdChange(Sender);
    MyPlayer.GoalSet.Clear;
  end;
  EdPlayerId.ItemIndex:= OldId;
  UpdateGoals;
end;


// ******************
// ** TEAM'S GOALS **
// ******************

procedure TFormTest2D.DeleteallTeamsGoals1Click(Sender: TObject);
begin
  MyTeam.GoalSet.Clear;
  UpdateGoals;
end;

procedure TFormTest2D.Runfast1Click(Sender: TObject);
begin
  MyTeam.GoalSet.AddGoal(TGoal2dRaced.create(MyTeam));
  UpdateGoals;
end;

procedure TFormTest2D.Addateamgoalforcollectingdrops1Click(
  Sender: TObject);
begin
  MyTeam.GoalSet.AddGoal(TGoal2dSweets.create(MyTeam));
  UpdateGoals;
  // Activate debug team goals:
  MenuDebugTeamGoals.Checked:= true;
  EdDebugChange(Sender);
end;

procedure TFormTest2D.Addateamgoalforstoringcollecteddrops1Click(
  Sender: TObject);
var x, y: integer;
const Size: integer = 6;
begin
  // Find a place on the track for the store box:
  repeat
    x:= round((0.1+0.8*random) * MyTrack.Width);
    y:= round((0.1+0.8*random) * MyTrack.Height);
  until MyTrack.IsInsideTrack(x-Size,y-Size) and
        MyTrack.IsInsideTrack(x-Size,y+Size) and
        MyTrack.IsInsideTrack(x+Size,y-Size) and
        MyTrack.IsInsideTrack(x+Size,y+Size);
  MyTeam.GoalSet.AddGoal(TGoal2dStorage.create(MyTeam, x, y, Size, 500));
  UpdateGoals;
  // Activate debug team goals:
  MenuDebugTeamGoals.Checked:= true;
  EdDebugChange(Sender);
end;

procedure TFormTest2D.AvoidOtherPlayersClick(Sender: TObject);
begin
  // I will, do MyTEam to run away from MyTeam again...
  MyTeam.GoalSet.AddGoal(TGoal2dTeamAway.create(MyTeam, MyTeam));
  UpdateGoals;
end;

procedure TFormTest2D.FollowMouseClick(Sender: TObject);
begin
  MyTeam.GoalSet.AddGoal(TGoalMouse.create(MyTeam, TComponent(Sender).Tag=1));
  UpdateGoals;
  // Activate debug team goals:
  MenuDebugTeamGoals.Checked:= true;
  EdDebugChange(Sender);
end;

procedure TFormTest2D.Suckenergyfromplayersinfrontofyou1Click(
  Sender: TObject);
begin
  MyPlayer.GoalSet.AddGoal(TGoalBurnOut.create(MyPlayer));
  UpdateGoals;
  // Activate debug team goals:
  MenuDebugGoals.Checked:= true;
  EdDebugChange(Sender);
end;

procedure TFormTest2D.Keepenergyhunger1Click(Sender: TObject);
begin
  MyTeam.GoalSet.AddGoal(TGoalEnergy.create(MyTeam));
  UpdateGoals;
end;

procedure TFormTest2D.Keephealth1Click(Sender: TObject);
begin
  MyTeam.GoalSet.AddGoal(TGoalHealth.create(MyTeam));
  UpdateGoals;
end;


// ***************
// ** MAIN LOOP **
// ***************

procedure TFormTest2D.RunSimulation;
var
  t: integer;
const
  // Each simulation tick correspond to 100 ms (0.1s).
  Sim_time: integer = 100;
begin
  Randomize;
  // Remeber actual state as initial (reset button will come to this point):
  for t:= 0 to MyTrack.TeamCount-1 do
    MyTrack.Team[t].SetIniState;
  // Main loop is here, may be it should be moved inside TTrack and send a pointer
  // to this form so the track can update the input controls on the form.
  while StartBtn.Down do begin
    // Think about next frame, make all the moves, redraw the track:
    MyTrack.TakeAStep;
    // Update screen dials:
    UpdateRealTimeParams;
    // Refresh screen:
    Application.ProcessMessages;
    // Save image to folder?
    if Saveimagestofolder.Checked then begin
      ImgRoad.Picture.SaveToFile(SaveDialog.FileName+'_'+Format('%5.5d', [ImgNumber])+'.bmp');
      inc(ImgNumber);
    end;
  end;
end;


// ***********************************
// ** MANAGING PLAYERS ON THE TRACK **
// ***********************************

function TFormTest2D.GetMyTeam: TTeam;
begin
  result:= MyTrack.SelectedTeam;
end;

function TFormTest2D.GetMyPlayer: TPhysic2D;
begin
  result:= TPhysic2D(MyTeam.SelectedPlayer);
end;

// Pressed "Add" a new player to the team:
procedure TFormTest2D.BtnAddPlayerClick(Sender: TObject);
begin
  AddPlayer(TComponent(Sender).Tag);
  MyTrack.Draw(-1);
end;

// New asteroid:
procedure TFormTest2D.Addlotsofasteroids1Click(Sender: TObject);
var i: integer;
begin
  for i:= 1 to 5 do begin
    AddPlayer(3);
  end;
  MyTrack.Draw(-1);
end;

// Add a player to the team:
procedure TFormTest2D.AddPlayer(kind: integer);
var
  OldPlayer: TPhysic2D;
begin
  // Remember old selected player:
  OldPlayer:= MyPlayer;
  // Kind of player to create?
  if (Kind=0) then begin
    // Try to clone selected player:
    if MyPlayer is TRocket then
      Kind:= 2
    else if MyPlayer is TKart then
      Kind:= 1
    else if MyPlayer is TPolygon2D then
      Kind:= 3;
  end;
  // Add a new one of this kind:
  case Kind of
    1: MyTeam.AddPlayer(TKart.create(330, 305, 0));
    2: MyTeam.AddPlayer(TRocket.create(350, 400, -PI/2));
    3: MyTeam.AddPlayer(TPolygon2D.create(330, 300, -PI/2, 5));
  else
    exit;
  end;
  // Copy params from previously selected player:
  if Assigned(OldPlayer) then begin
    if (OldPlayer.ClassType = MyPlayer.ClassType) then begin
      // Both are of the same kind:
      // Copy all player params:
      MyPlayer.CopyFrom(OldPlayer);
      // Clone goal strenghts:
      MyPlayer.GoalSet.CopyFrom(OldPlayer.GoalSet);
      // Don't place it over the old one (align with existing similar players):
      if (MyTeam.PlayerCount>2) then begin
        MyPlayer.PosX:= MyPlayer.PosX + ( TPhysic2D(MyTeam.Player[MyTeam.PlayerCount-2]).PosX - TPhysic2D(MyTeam.Player[MyTeam.PlayerCount-3]).PosX);
        MyPlayer.PosY:= MyPlayer.PosY + ( TPhysic2D(MyTeam.Player[MyTeam.PlayerCount-2]).PosY - TPhysic2D(MyTeam.Player[MyTeam.PlayerCount-3]).PosY);
      end else begin
        MyPlayer.PosX:= MyPlayer.PosX + Cos(MyPlayer.Angle) * 30;
        MyPlayer.PosY:= MyPlayer.PosY + Sin(MyPlayer.Angle) * 30;
      end;
    end;
  end;
  // Asteroids use to show the trails (with uncertainty):
  if (Kind=3) then begin
    MyPlayer.DebugTraces:= true;
    // Random size and num of sides:
    MyPlayer.size:= 5 + round(random*10);
    TPolygon2D(MyPlayer).NumSides:= 3 + round(random*3);
    // Random initial velocity:
    MyPlayer.VelX:= (random-0.5)*100;
    MyPlayer.VelY:= (random-0.5)*100;
    // Locate it on a free space in the upper third of the screen:
    repeat
      MyPlayer.PosX:= MyTrack.Width  * (0.15+0.7*random);
      MyPlayer.PosY:= MyTrack.Height * (0.10+0.3*random); // Upper half of the screen
    until not MyTrack.PlayerCollides(MyPlayer);
  end else begin
    // Avoid overlaping players:
    while MyTrack.PlayerCollides(MyPlayer) do begin
      MyPlayer.PosX:= MyTrack.Width  * (0.1+0.8*random);
      MyPlayer.PosY:= MyTrack.Height * (0.1+0.8*random);
    end;
  end;
  // Evolution force strengths to be random:
  if MyTrack.Evolution then
    MyPlayer.GoalSet.RandomizeGoals;
  // Asign colors:
  if MyTrack.Evolution then begin
    // When Evolution is ON, color is defined by goals strength:
    MyPlayer.GoalSet.ColorizeOwner;
    MyPlayer.GoalSet.Debug:= true;
  end else begin
    // Usually the colors are from a fixed list:
    if (MyTrack.PlayerCount = 1) then MyPlayer.Color:= clWhite;
    if (MyTrack.PlayerCount = 2) then MyPlayer.Color:= clYellow;
    if (MyTrack.PlayerCount = 3) then MyPlayer.Color:= RGB2Color(255,150,100); // Orange
    if (MyTrack.PlayerCount = 4) then MyPlayer.Color:= clRed;
    if (MyTrack.PlayerCount = 5) then MyPlayer.Color:= RGB2Color(180,180,180); // Grey
  end;
  // Add it to the combo box:
  EdPlayerId.Items.Add('Player #'+IntToStr(MyTrack.PlayerCount));
  EdPlayerId.ItemIndex:= EdPlayerId.Items.Count-1;
  // Refresh screen image and controls:
  CopyParamsFromPlayer;
  MyTrack.Draw(-1);
end;

// Delete actual kart from the team:
procedure TFormTest2D.BtnSubPlayerClick(Sender: TObject);
begin
  if MyTrack.PlayerCount > 1 then begin
    // Delete kart:
    MyTeam.DelPlayer(MyPlayer, true);
    // Take from the ComboBox list:
    EdPlayerId.Items.Delete(EdPlayerId.Items.Count-1);
    EdPlayerId.ItemIndex:= EdPlayerId.Items.Count-1;
    // Redraw all:
    EdPlayerIdChange(Sender);
    MyTrack.ClearTrack;
    MyTrack.Draw(-1);
  end;
end;

// Selected player is changed, so update screen dials:
procedure TFormTest2D.EdPlayerIdChange(Sender: TObject);
begin
  MyTeam.SelectedPlayer:= MyTeam.Player[EdPlayerId.ItemIndex];
  CopyParamsFromPlayer;
end;

// Chose another color for the selected kart:
procedure TFormTest2D.EdColorClick(Sender: TObject);
begin
  ColorDialog.Color:= EdColor.Color;
  if ColorDialog.Execute then begin
    EdColor.Color:= ColorDialog.Color;
    MyPlayer.Color:= EdColor.Color;
    MyTrack.Draw(-1);
  end;
end;



// ***********************
// ** MENUS AND BUTTONS **
// ***********************

// RUN is pressed
procedure TFormTest2D.StartBtnClick(Sender: TObject);
begin
  // Activate the main loop:
  RunSimulation;
end;

// PAUSE simulation (from menu, button works auto):
procedure TFormTest2D.Pausesimulation1Click(Sender: TObject);
begin
  PauseBtn.Down:= true;
end;

// RESET pressed:
procedure TFormTest2D.ResetBtnClick(Sender: TObject);
var
  t: integer;
begin
  ImgNumber:= 1;
  for t:= 0 to MyTrack.TeamCount-1 do
    MyTrack.Team[t].ResetState;
  CopyParamsFromScreen;
  MyTrack.Draw(-1);
end;

// Loading a new image for the track form menu:
procedure TFormTest2D.Loadcircuit800x600BMP1Click(Sender: TObject);
var
  Ext: string;
  //TmpPicture: TPicture;
begin
  if OpenPictureDialog.Execute then begin
    Ext:= UpperCase(ExtractFileExt(OpenPictureDialog.FileName));
    // BMPs and PNGs load in a different way:
    if (Ext='.PNG') then begin
      // Neither method worked for me (on D7) so droping PNG support!
      //
      //TmpPicture:= TPicture.create;
      //TmpPicture.Graphic:= TPNGObject.create;
      //TPNGObject(TmpPicture.Graphic).LoadFromFile(OpenPictureDialog.FileName);
      //ImgRoad.Picture.Assign(TmpPicture);
      //
      //ImgRoad.Picture.Assign(TPicture.create);
      //ImgRoad.Picture.Graphic:= TPNGObject.create;
      //TPNGObject(ImgRoad.Picture.Graphic).LoadFromFile(OpenPictureDialog.FileName);
    end else if (Ext='.BMP') then begin
      ImgRoad.Picture.LoadFromFile(OpenPictureDialog.FileName);
    end;
    // Scan new track:
    MyTrack.Img:= ImgRoad;
    // Repaint karts on it:
    MyTrack.Draw(-1);
  end;
end;

// Selecting a folder (and file name) where to save images:
procedure TFormTest2D.SaveimagestofolderClick(Sender: TObject);
begin
  // Switch on/off image recording:
  if SaveImagesToFolder.Checked then begin
    if not SaveDialog.Execute then
      SaveImagesToFolder.Checked:= false;
  end;
end;


// ***********************
// ** SIMULATION PARAMS **
// ***********************

// Transfer screen params to the actual player and track:
procedure TFormTest2D.CopyParamsFromScreen;
begin
  // Player params:
  EdSizeChange(nil);
  EdDeterminedChange(nil);
  EdRadioChange(nil);
  EdAutoRadioClick(nil);
  EdSensitivityClick(nil);
  // Track params.
  EdFrictionChange(nil);
  EdSideFrictionChange(nil);
  // Think params.
  EdSecondsChange(nil);
  EdMinFuturesChange(nil);
  EdCollisionsClick(nil);
  // Debug params.
  EdDebugChange(nil);
end;

// Transfer params from the actual player and track to screen:
procedure TFormTest2D.CopyParamsFromPlayer;
begin
  EdSeconds.Position:=      round(MyTrack.FutureMSeconds/1000);
  EdMinFutures.Position:=   MyTrack.NumFutures;
  EdSize.Position:=         round(MyPlayer.Size);
  EdDetermined.Position:=   round(MyPlayer.Determined*100);
  EdFriction.Position:=     round(MyTrack.Friction*10000);
  EdSideFriction.Position:= round(MyTrack.SideFriction*100);
  EdColor.Color:=           MyPlayer.Color;
  EdRadio.Max:=             MyPlayer.MaxGridSize;
  EdRadio.Min:=             MyPlayer.MinGridSize;
  EdAutoRadio.Checked:=     MyPlayer.AutoGridSize;
  EdSensitivity.Checked:=   MyPlayer.UseLimiters;
  // Update goals panel:
  UpdateGoals;
  // Read params that change during simulation:
  UpdateRealTimeParams;
  // Debug menu:
  MenuDebugTraces.Checked:=  MyPlayer.DebugTraces;
  MenuDebugOptions.Checked:= MyPlayer.DebugOptions;
  MenuDebugGoals.Checked:=   MyPlayer.GoalSet.Debug;
  MenuDebugLevels.Checked:=  MyPlayer.DebugLevels;
  // Update labels:
  CopyParamsFromScreen;
end;


// *****************
// ** GOALS PANEL **
// *****************

// Update goals panel:
procedure TFormTest2D.UpdateGoals;
var
  i: integer;

  procedure AddGoal(t: integer; Goal: TGoal);
  var
    GB: TGroupBox;
    Lb: TLabel;
    Tb: TTrackBar;
    h: integer;
    Id: string;
  const
    sLeft: integer =  55;
    sRigth: integer = 35;
  begin
    // GroupBox for the goal's parameters:
    GB:= TGroupBox.create(EdGoals);
    GB.Parent:= EdGoals;
    GB.PopupMenu:= PopupGoalParam;
    GB.Tag:= t;
    GB.Align:= alTop;
    GB.Caption:= 'GOAL "' + Goal.DisplayName + '"';
    // Id for controls:
    Id:= IntToStr(abs(t));
    if (t<0) then begin
      GB.Caption:= GB.Caption + ' (team)';
      Id:= Id+'_T';
    end;
    h:= 24;
    GB.Height:= h + 10;
    // Strength
    // ========
    //
    // Title:
    Lb:= TLabel.create(GB);
    Lb.Parent:= GB;
    Lb.PopupMenu:= PopupGoalParam;
    Lb.Tag:= t;
    Lb.Top:= h;
    Lb.Left:= 10;
    Lb.Caption:= 'Strength';
    Lb.Hint:= 'How strong the goal is for the player.';
    // Value:
    Lb:= TLabel.create(GB);
    Lb.Parent:= GB;
    Lb.PopupMenu:= PopupGoalParam;
    Lb.Tag:= t;
    Lb.Name:= 'STRENGTH_'+Id;
    Lb.AutoSize:= false;
    Lb.Alignment:= taRightJustify;
    Lb.Left:= GB.ClientWidth - sRigth;
    Lb.Width:= sRigth-10;
    Lb.Top:= h;
    Lb.Caption:= Format('%3.2f', [Goal.Strength]);
    // Slider:
    Tb:= TTrackBar.Create(GB);
    Tb.Parent:= GB;
    Tb.PopupMenu:= PopupGoalParam;
    Tb.Tag:= t;
    Tb.TickStyle:= tsNone;
    Tb.ThumbLength:= 9;
    Tb.Left:= sLeft;
    Tb.Top:= h+4;
    Tb.Width:= GB.ClientWidth - Tb.Left - sRigth;
    Tb.Height:= 17;
    Tb.Max:= 100;
    Tb.Min:=   0;
    Tb.Frequency:= 5;
    Tb.Position:= round(100*Goal.Strength/Goal.MaxStrength);
    Tb.OnChange:= ReadGoalStrength;
    // New line:
    h:= h + 14;
    GB.Height:= h + 10;
    // If goal has ReactionTime, add 2 more sliders:
    if (Goal.ReactionMSeconds > 0) then begin
      // Reaction time
      // =============
      //
      // Title:
      Lb:= TLabel.create(GB);
      Lb.Parent:= GB;
      Lb.PopupMenu:= PopupGoalParam;
      Lb.Tag:= t;
      Lb.Top:= h;
      Lb.Left:= 10;
      Lb.Caption:= 'Reaction';
      Lb.Hint:= 'How early you want to be warned before a problem.';
      // Value:
      Lb:= TLabel.create(GB);
      Lb.Parent:= GB;
      Lb.PopupMenu:= PopupGoalParam;
      Lb.Tag:= t;
      Lb.Name:= 'REACTION_'+Id;
      Lb.AutoSize:= false;
      Lb.Alignment:= taRightJustify;
      Lb.Left:= GB.ClientWidth - sRigth;
      Lb.Width:= sRigth-10;
      Lb.Top:= h;
      Lb.Caption:= Format('%3.1fs', [Goal.ReactionMSeconds/1000]);
      // Slider:
      Tb:= TTrackBar.Create(GB);
      Tb.Parent:= GB;
      Tb.PopupMenu:= PopupGoalParam;
      Tb.Tag:= t;
      Tb.TickStyle:= tsNone;
      Tb.ThumbLength:= 9;
      Tb.Left:= sLeft;
      Tb.Top:= h+4;
      Tb.Width:= GB.ClientWidth - Tb.Left - sRigth;
      Tb.Height:= 17;
      Tb.Max:= 100;
      Tb.Min:=   0;
      Tb.Frequency:= 5;
      Tb.Position:= round(100 * Goal.ReactionMSeconds/1000/10);
      Tb.OnChange:= ReadGoalReactionTime;
      // New line:
      h:= h + 14;
      GB.Height:= h + 10;
      // Urgency
      // =======
      //
      // Title:
      Lb:= TLabel.create(GB);
      Lb.Parent:= GB;
      Lb.PopupMenu:= PopupGoalParam;
      Lb.Tag:= t;
      Lb.Top:= h;
      Lb.Left:= 10;
      Lb.Caption:= 'Urgency';
      Lb.Hint:= 'Once it start warning you, how fast warning grows.';
      // Value:
      Lb:= TLabel.create(GB);
      Lb.Parent:= GB;
      Lb.PopupMenu:= PopupGoalParam;
      Lb.Tag:= t;
      Lb.Name:= 'URGENCY_'+Id;
      Lb.AutoSize:= false;
      Lb.Alignment:= taRightJustify;
      Lb.Left:= GB.ClientWidth - sRigth;
      Lb.Width:= sRigth-10;
      Lb.Top:= h;
      Lb.Caption:= Format('%3.2f', [Goal.Urgency]);
      // Slider:
      Tb:= TTrackBar.Create(GB);
      Tb.Parent:= GB;
      Tb.PopupMenu:= PopupGoalParam;
      Tb.Tag:= t;
      Tb.TickStyle:= tsNone;
      Tb.ThumbLength:= 9;
      Tb.Left:= sLeft;
      Tb.Top:= h+4;
      Tb.Width:= GB.ClientWidth - Tb.Left - sRigth;
      Tb.Height:= 17;
      Tb.Max:= 100;
      Tb.Min:=   0;
      Tb.Frequency:= 5;
      Tb.Position:= round(100 * Goal.Urgency/2);
      Tb.OnChange:= ReadGoalUrgency;
      // New line:
      h:= h + 14;
      GB.Height:= h + 10;
    end;
    EdGoals.Height:= EdGoals.Height + GB.Height;
  end;

begin
  // Clean the list:
  while EdGoals.ComponentCount>0 do
    EdGoals.Components[0].Free;
  EdGoals.Height:= 1;
  // Add player's goals:
  for i:= 0 to MyPlayer.GoalSet.Count-1 do
    AddGoal(+(i+1), MyPlayer.GoalSet.Goal[i]);
  // Add team's goals:
  for i:= 0 to MyTeam.GoalSet.Count-1 do
    AddGoal(-(i+1), MyTeam.GoalSet.Goal[i]);
end;

// User moved the goal strength, update it:
procedure TFormTest2D.ReadGoalStrength(Sender: TObject);
var
  t, n, i: integer;
  Team: boolean;
  Panel: TComponent;
  Goal: TGoal;
begin
  // Team or Player goal? Witch number?
  Panel:= TControl(Sender).Parent;
  t:= Panel.Tag;
  Team:= (t<0);
  n:= abs(t)-1;
  if team then
    Goal:= MyTeam.GoalSet.Goal[n]
  else
    Goal:= MyPlayer.GoalSet.Goal[n];
  // Update goal coef:
  Goal.Strength:= TTrackBar(Sender).Position/100 * Goal.MaxStrength;
  // Update screen label:
  for i:= 0 to Panel.ComponentCount-1 do begin
    if (Panel.Components[i] is TLabel) and
       (Copy(TLabel(Panel.Components[i]).Name, 1, 5) = 'STREN') then
      TLabel(Panel.Components[i]).Caption:= Format('%3.2f', [Goal.Strength]);
  end;
end;

// User moved the goal ReactionTime, update it:
procedure TFormTest2D.ReadGoalReactionTime(Sender: TObject);
var
  t, n, i: integer;
  Team: boolean;
  Panel: TComponent;
  Goal: TGoal;
begin
  // Team or Player goal? Witch number?
  t:= TComponent(Sender).Tag;
  Team:= (t<0);
  n:= abs(t)-1;
  if team then
    Goal:= MyTeam.GoalSet.Goal[n]
  else
    Goal:= MyPlayer.GoalSet.Goal[n];
  // Update goal coef:
  Goal.ReactionMSeconds:= round(TTrackBar(Sender).Position/100 * 10000);
  // Update screen label:
  Panel:= TControl(Sender).Parent;
  for i:= 0 to Panel.ComponentCount-1 do begin
    if (Panel.Components[i] is TLabel) then
      if (Copy(TLabel(Panel.Components[i]).Name, 1, 5) = 'REACT') then
        TLabel(Panel.Components[i]).Caption:= Format('%3.1fs', [Goal.ReactionMSeconds/1000]);
  end;
end;

// User moved the goal ReactionTime, update it:
procedure TFormTest2D.ReadGoalUrgency(Sender: TObject);
var
  t, n, i: integer;
  Team: boolean;
  Panel: TComponent;
  Goal: TGoal;
begin
  // Team or Player goal? Witch number?
  t:= TComponent(Sender).Tag;
  Team:= (t<0);
  n:= abs(t)-1;
  if team then
    Goal:= MyTeam.GoalSet.Goal[n]
  else
    Goal:= MyPlayer.GoalSet.Goal[n];
  // Update goal coef:
  Goal.Urgency:= TTrackBar(Sender).Position/100 * 2;
  // Update screen label:
  Panel:= TControl(Sender).Parent;
  for i:= 0 to Panel.ComponentCount-1 do begin
    if (Panel.Components[i] is TLabel) then
      if (Copy(TLabel(Panel.Components[i]).Name, 1, 5) = 'URGEN') then
        TLabel(Panel.Components[i]).Caption:= Format('%3.2f', [Goal.Urgency]);
  end;
end;

// Only some params do change during simulation, only refresh those:
procedure TFormTest2D.UpdateRealTimeParams;
begin
  EdRadio.Position:= round(MyPlayer.GridSize);
end;


// ************************
// ** CHANGING ONE PARAM **
// ************************

procedure TFormTest2D.EdMinFuturesChange(Sender: TObject);
begin
  MyTrack.NumFutures:= EdMinFutures.Position;
  LbMinFutures.Caption:= IntToStr(EdMinFutures.Position);
end;

procedure TFormTest2D.EdAutoRadioClick(Sender: TObject);
begin
  MyPlayer.AutoGridSize:= EdAutoRadio.Checked;
end;

procedure TFormTest2D.EdSensitivityClick(Sender: TObject);
begin
  MyPlayer.UseLimiters:= EdSensitivity.Checked;
end;

procedure TFormTest2D.EdFrictionChange(Sender: TObject);
begin
  LbFriction.Caption:= IntToStr(round(EdFriction.Position/10))+'%';
  MyTrack.Friction:= EdFriction.Position/10000;
end;

procedure TFormTest2D.EdSideFrictionChange(Sender: TObject);
begin
  LbSideFriction.Caption:=  FloatToStr(EdSideFriction.Position)+'%';
  MyTrack.SideFriction:= EdSideFriction.Position/100;
end;

// What to debug?
procedure TFormTest2D.EdDebugChange(Sender: TObject);
begin
  MyPlayer.DebugTraces:=   MenuDebugTraces.Checked;
  MyPlayer.DebugFeelings:= MenuDebugFeelings.Checked;
  MyPlayer.DebugOptions:=  MenuDebugOptions.Checked;
  MyPlayer.DebugLevels:=   MenuDebugLevels.Checked;
  MyPlayer.GoalSet.Debug:= MenuDebugGoals.Checked;
  MyTeam.GoalSet.Debug:=   MenuDebugTeamGoals.Checked;
  MyTrack.Draw(-1);
end;

procedure TFormTest2D.EdSizeChange(Sender: TObject);
begin
  MyPlayer.Size:= EdSize.Position;
  LbSize.Caption:= IntToStr(EdSize.Position)+ 'px';
  MyTrack.Draw(-1);
end;

procedure TFormTest2D.EdDeterminedChange(Sender: TObject);
begin
  MyPlayer.Determined:= EdDetermined.Position / 100;
  LbDetermined.Caption:= IntToStr(EdDetermined.Position)+ '%';
  MyTrack.Draw(-1);
end;

procedure TFormTest2D.EdRadioChange(Sender: TObject);
begin
  MyPlayer.GridSize:= EdRadio.Position;
  LbRadio.Caption:= IntToStr(EdRadio.Position)+ 'px';
end;

procedure TFormTest2D.EdSecondsChange(Sender: TObject);
begin
  MyTrack.FutureMSeconds:= EdSeconds.Position * 1000;
  LbSeconds.Caption:= IntToStr(EdSeconds.Position)+' s.'
end;

procedure TFormTest2D.EdCollisionsClick(Sender: TObject);
begin
  MyTrack.PlayersCollide:= EdCollisions.Checked;
end;


// *******************************
// ** MOVING THE PLAYER BY HAND **
// *******************************

// Press a move button:
procedure TFormTest2D.MoveButtonMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if not StartBtn.Down then begin
    HandMove(TControl(Sender).Tag);
    ArrowTimer.Tag:= TControl(Sender).Tag;
    ArrowTimer.Interval:= 500;
    ArrowTimer.Enabled:= true;
  end;
end;

// Release a move button:
procedure TFormTest2D.MoveButtonMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ArrowTimer.Enabled:= false;
end;

// Keep pressing a move button? Repeat moving:
procedure TFormTest2D.ArrowTimerTimer(Sender: TObject);
begin
  HandMove(ArrowTimer.Tag);
  if ArrowTimer.Interval = 500 then
    ArrowTimer.Interval:= 150
  else if (ArrowTimer.Interval > 20) then
    ArrowTimer.Interval:= ArrowTimer.Interval - 5;
end;

// Dir: 1 left, 2 rigth, 3 up, 4 down, 5 rotate left, 6 rotate right
procedure TFormTest2D.HandMove(dir: integer);
begin
  // Move it:
  case Dir of
    1: MyPlayer.HandMove(-5, 0, 0);
    2: MyPlayer.HandMove(+5, 0, 0);
    3: MyPlayer.HandMove(0, -5, 0);
    4: MyPlayer.HandMove(0, +5, 0);
    5: MyPlayer.HandMove(0, 0, -PI/12);
    6: MyPlayer.HandMove(0, 0, +PI/12);
  end;
  // Redraw?
  if not StartBtn.Down then
    MyTrack.Draw(-1);
end;


// Refill energy of the player:
procedure TFormTest2D.SpeedButton8Click(Sender: TObject);
begin
  case TComponent(Sender).Tag of
    0: MyPlayer.Energy:= MyPlayer.Energy + 10;
    1: MyPlayer.Health:= MyPlayer.Health + 10;
    2: MyPlayer.Energy:= Max(10, MyPlayer.Energy - 10);
    3: MyPlayer.Health:= Max(10, MyPlayer.Health - 10);
  end;
  if not StartBtn.Down then
    MyTrack.draw(-1);
end;

// Activate panels:
procedure TFormTest2D.menuPlayerParamsClick(Sender: TObject);
begin
  EdAIParams.Visible:=     menuBasicAIparams.Checked;
  EdChoosePlayer.Visible:= menuChoosePlayer.Checked;
  EdPlayerParams.Visible:= menuPlayerParams.Checked;
  EdGoals.Visible:=        menuGoals.Checked;
  EdHandMove.Visible:=     menuHandMove.Checked;
  EdTrackParams.Visible:=  menuTrackParams.Checked;
end;

procedure TFormTest2D.FormResize(Sender: TObject);
begin
  // Keep image ratio at 800x600
  ImgRoad.Height:= Min(PanelImg.ClientHeight, round(PanelImg.ClientWidth/800*600));
  ImgRoad.Width := Min(PanelImg.ClientWidth,  round(PanelImg.ClientHeight*800/600));
end;


procedure TFormTest2D.EdPlayerIdEnter(Sender: TObject);
var
  i, Id: integer;
  ActualPlayer: TPlayer;
begin
  // Reload player list from track records:
  ActualPlayer:= MyTrack.SelectedTeam.SelectedPlayer;
  Id:= 0;
  EdPlayerId.Clear;
  MyTrack.RefreshPlayerList;
  for i:= 0 to MyTrack.SelectedTeam.PlayerCount-1 do begin
    EdPlayerId.Items.Add('Player #'+IntToStr(i+1));
    // Must I left this one selected at the end?
    if (MyTrack.SelectedTeam.Player[i] = ActualPlayer) then
      Id:= i;
  end;
  // Select the "old selected player" on the new list:
  EdPlayerId.ItemIndex:= Id;
end;

procedure TFormTest2D.EdEvolutionClick(Sender: TObject);
begin
  MyTrack.Evolution:= EdEvolution.Checked;
end;

procedure TFormTest2D.SpeedButton8DblClick(Sender: TObject);
begin
  if TComponent(Sender).Tag=0 then
    MyPlayer.Energy:= 100 //MyPlayer.Energy + 100
  else
    MyPlayer.Health:= 100; //MyPlayer.Health + 100;
  MyTrack.draw(-1);
end;


end.
