unit UGoalLander;

interface

uses UGoal, UPlayer;

type TGoalLander = class(TGoal)
  private
  protected
    procedure ReadQuantity(v: TObject); override;
  public
    constructor create(Sender: TObject); override;
  end;


implementation

uses Math, UPhysic2D;


constructor TGoalLander.create(Sender: TObject);
begin
  inherited;
  DisplayName:= 'Lander';
end;

procedure TGoalLander.ReadQuantity(v: TObject);
begin
  // Dividing by 10 just adjust scales so I can safely use goals with strength of 1
  if TPhysic2D(v).Landed then
    Quantity:= 10
  else
    Quantity:= 0;
  OldQuantity:= Quantity;
end;

end.
