unit UGoal2DRaced;

interface

uses UGoal, UPhysic2D;

type TGoal2DRaced = class(TGoal)
  private
  protected
    procedure ReadQuantity(v: TObject); override;
  public
    constructor create(Sender: TObject); override;
  end;


implementation

uses Math;


constructor TGoal2dRaced.create(Sender: TObject);
begin
  inherited;
  DisplayName:= 'Speeding';
end;

procedure TGoal2dRaced.ReadQuantity(v: TObject);
begin
  // Dividing by 10 just adjust scales so I can safely use goals with strength of 1
  OldQuantity:= Sqrt(Sqr(TPhysic2D(v).OldVelX) + Sqr(TPhysic2D(v).OldVelY)) / TPhysic2D(v).Size;
  Quantity:=    Sqrt(Sqr(TPhysic2D(v).VelX)    + Sqr(TPhysic2D(v).VelY))    / TPhysic2D(v).Size;
end;

end.
